diff -u -r gdm-2.28.2.pristine/gui/simple-greeter/gdm-user-manager.h gdm-2.28.2/gui/simple-greeter/gdm-user-manager.h
--- gdm-2.28.2.pristine/gui/simple-greeter/gdm-user-manager.h	2010-01-22 11:17:50.300384192 -0500
+++ gdm-2.28.2/gui/simple-greeter/gdm-user-manager.h	2010-01-24 00:14:29.430538656 -0500
@@ -1,10 +1,10 @@
 /* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*-
  *
- * Copyright (C) 2007 William Jon McCann <mccann@jhu.edu>
+ * Copyright (C) 2009-2010 Red Hat, Inc.
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License, or
+ * the Free Software Foundation; either version 3 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
@@ -18,10 +18,11 @@
  *
  */
 
-#ifndef __GDM_USER_MANAGER_H
-#define __GDM_USER_MANAGER_H
+#ifndef __GDM_USER_MANAGER__
+#define __GDM_USER_MANAGER__
 
 #include <glib-object.h>
+#include <dbus/dbus-glib.h>
 
 #include "gdm-user.h"
 
@@ -34,54 +35,57 @@
 #define GDM_IS_USER_MANAGER_CLASS(k)  (G_TYPE_CHECK_CLASS_TYPE ((k), GDM_TYPE_USER_MANAGER))
 #define GDM_USER_MANAGER_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), GDM_TYPE_USER_MANAGER, GdmUserManagerClass))
 
-typedef struct GdmUserManagerPrivate GdmUserManagerPrivate;
-
 typedef struct
 {
-        GObject                parent;
-        GdmUserManagerPrivate *priv;
+        GObject parent;
+
+        DBusGConnection *bus;
+        DBusGProxy *proxy;
+
+        GHashTable *user_by_object_path;
+        GHashTable *user_by_name;
+
+        gboolean no_service;
+
+        GHashTable *sessions;
+        DBusGProxy *seat_proxy;
+        gchar      *seat_id;
 } GdmUserManager;
 
 typedef struct
 {
         GObjectClass   parent_class;
 
-        void          (* loading_users)             (GdmUserManager *user_manager);
-        void          (* users_loaded)              (GdmUserManager *user_manager);
+        void          (* users_loaded)              (GdmUserManager *user_managaer);
         void          (* user_added)                (GdmUserManager *user_manager,
                                                      GdmUser        *user);
         void          (* user_removed)              (GdmUserManager *user_manager,
                                                      GdmUser        *user);
+        void          (* user_changed)              (GdmUserManager *user_manager,
+                                                     GdmUser        *user);
         void          (* user_is_logged_in_changed) (GdmUserManager *user_manager,
                                                      GdmUser        *user);
-        void          (* user_login_frequency_changed) (GdmUserManager *user_manager,
-                                                        GdmUser        *user);
 } GdmUserManagerClass;
 
-typedef enum
-{
-        GDM_USER_MANAGER_ERROR_GENERAL,
-        GDM_USER_MANAGER_ERROR_KEY_NOT_FOUND
-} GdmUserManagerError;
-
-#define GDM_USER_MANAGER_ERROR gdm_user_manager_error_quark ()
 
-GQuark              gdm_user_manager_error_quark           (void);
-GType               gdm_user_manager_get_type              (void);
+GType              gdm_user_manager_get_type              (void);
 
 GdmUserManager *    gdm_user_manager_ref_default           (void);
 
-GSList *            gdm_user_manager_list_users            (GdmUserManager *manager);
-GdmUser *           gdm_user_manager_get_user              (GdmUserManager *manager,
-                                                            const char     *user_name);
-GdmUser *           gdm_user_manager_get_user_by_uid       (GdmUserManager *manager,
-                                                            uid_t           uid);
+gboolean           gdm_user_manager_no_service            (GdmUserManager *manager);
 
-gboolean            gdm_user_manager_activate_user_session (GdmUserManager *manager,
-                                                            GdmUser        *user);
-
-gboolean            gdm_user_manager_goto_login_session    (GdmUserManager *manager);
+GSList *           gdm_user_manager_list_users            (GdmUserManager *manager);
+GdmUser *           gdm_user_manager_get_user              (GdmUserManager *manager,
+                                                          const char    *user_name);
+GdmUser *           gdm_user_manager_get_user_by_id        (GdmUserManager *manager,
+                                                          uid_t          uid);
+void               gdm_user_manager_create_user           (GdmUserManager *manager,
+                                                          const char    *user_name,
+                                                          const char    *real_name);
+void               gdm_user_manager_delete_user           (GdmUserManager *manager,
+                                                          GdmUser        *user,
+                                                          gboolean       remove_files);
 
 G_END_DECLS
 
-#endif /* __GDM_USER_MANAGER_H */
+#endif /* __GDM_USER_MANAGER__ */
diff -u -r gdm-2.28.2.pristine/gui/simple-greeter/gdm-user-private.h gdm-2.28.2/gui/simple-greeter/gdm-user-private.h
--- gdm-2.28.2.pristine/gui/simple-greeter/gdm-user-private.h	2010-01-22 11:17:50.325386253 -0500
+++ gdm-2.28.2/gui/simple-greeter/gdm-user-private.h	2010-01-23 22:13:18.335788575 -0500
@@ -30,15 +30,11 @@
 
 G_BEGIN_DECLS
 
-void _gdm_user_update           (GdmUser             *user,
-                                 const struct passwd *pwent);
 void _gdm_user_add_session      (GdmUser             *user,
                                  const char          *session_id);
 void _gdm_user_remove_session   (GdmUser             *user,
                                  const char          *session_id);
 
-void _gdm_user_icon_changed     (GdmUser             *user);
-
 void _gdm_user_show_full_display_name (GdmUser   *user);
 void _gdm_user_show_short_display_name  (GdmUser   *user);
 
